﻿using System;

namespace JakiśProjekt
{
    using UMK;

    class Program
    {
        struct NeastedStruct
        {
            public int Integer { get; set; }

            public DateTime Date { get; set; }
        }

        class NeastedClass
        {
            public string Content { get; set; }
            public string Content2 { get; set; }

            public NeastedStruct strukturaZagniezdzona;
        }

        class Samochód
        {
            public Samochód() : this("trabant") {}

            public Samochód(string marka)
            {
                this.marka = marka;
            }

            private string marka;

            public string Marka
            {
                get => marka;
                set => marka = value;
            }

            public int Model;
            [NonSerialized] public int Podmodel;

            public int[] Tablica = { 1, 2, 3 };

            public enum _TypWyliczeniowy { Raz, Dwa, Trzy }
            public _TypWyliczeniowy TypWyliczeniowy = Samochód._TypWyliczeniowy.Dwa;

            public NeastedClass KlasaZagniezdzona { get; set; }
        }

        static void Main(string[] args)
        {
            Samochód samochód = new Samochód("Tesla")
            {
                Model = 1,
                KlasaZagniezdzona = new NeastedClass
                {
                    Content = "Content1",
                    Content2 = "Content2",
                    strukturaZagniezdzona = new NeastedStruct()
                    {
                        Integer = 256,
                        Date = DateTime.Now,
                    }
                }
            };
            SettingsManager<Samochód> sm = new SettingsManager<Samochód>(samochód, "s.xml");
            sm.Save();

            System.IO.File.Copy("s.xml", "r.xml", true);
            SettingsManager<Samochód> kopia = SettingsManager<Samochód>.Load("r.xml");
            Samochód skopia = kopia.GetSettingsObject();
            //bool wynik = samochód.Equals(skopia);
            //Console.WriteLine(wynik);
        }
    }
}
