﻿using System;
using System.Reflection;

namespace UMK
{
    public class FieldAdapter : IMemberAdapter
    {
        private readonly FieldInfo field;
        public FieldAdapter(FieldInfo fieldInfo)
        {
            this.field = fieldInfo;
        }

        public bool IsProper => !field.IsNotSerialized && !field.IsStatic;

        public string Name => field.Name;

        public Type Type => field.FieldType;

        public object GetValue(object obj) => field.GetValue(obj);

        public void SetValue(object obj, object value) => field.SetValue(obj, value);
    }
}
