﻿using System;
using System.Reflection;

namespace UMK
{
    public class PropertyAdapter : IMemberAdapter
    {
        private readonly PropertyInfo prop;
        public PropertyAdapter(PropertyInfo propertyInfo)
        {
            this.prop = propertyInfo;
        }

        public bool IsProper => prop.CanWrite;

        public string Name => prop.Name;

        public Type Type => prop.PropertyType;

        public object GetValue(object obj) => prop.GetValue(obj);

        public void SetValue(object obj, object value) => prop.SetValue(obj, value);
    }
}
